summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorP. J. McDermott <pjm@nac.net>2013-07-12 13:46:31 (EDT)
committer P. J. McDermott <pjm@nac.net>2013-07-12 13:46:31 (EDT)
commitdec733739a28b495b92e5e7bf2e2ce2ff2dcb5ed (patch)
treef381d90b560b5cd4707f6ac30506ab660d188f54
parent7097b57fc99a358bf81c41d61c0a4aacf6b58e61 (diff)
lib/locale.sh: New file.
-rw-r--r--lib/cmd.sh2
-rw-r--r--lib/local.mk1
-rw-r--r--lib/locale.sh79
3 files changed, 82 insertions, 0 deletions
diff --git a/lib/cmd.sh b/lib/cmd.sh
index ff81c4a..0f5ea95 100644
--- a/lib/cmd.sh
+++ b/lib/cmd.sh
@@ -20,6 +20,8 @@
[ "x${_CMD_SM+set}" = 'xset' ] && return 0
_CMD_SM=1
+use locale
+
cmds=
load_cmds()
diff --git a/lib/local.mk b/lib/local.mk
index e135474..a17b6e6 100644
--- a/lib/local.mk
+++ b/lib/local.mk
@@ -2,4 +2,5 @@
# lib/local.mk
pkglib_srcs = \
+ lib/locale.sh \
lib/cmd.sh
diff --git a/lib/locale.sh b/lib/locale.sh
new file mode 100644
index 0000000..33245aa
--- /dev/null
+++ b/lib/locale.sh
@@ -0,0 +1,79 @@
+# pro-archman
+# lib/locale.sh
+# Locale functions
+#
+# Copyright (C) 2012, 2013 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+[ "x${_LOCALE_SM+set}" = 'xset' ] && return 0
+_LOCALE_SM=1
+
+LOCALEDIR='@@LOCALEDIR@@'
+LOCALE_PATH='%s/%s/LC_MESSAGES/%s.ms'
+DEFAULT_LOCALE='en_US'
+TEXT_DOMAIN='pro_archman'
+
+load_locale()
+{
+ # Make sure LC_MESSAGES is set.
+ if [ "x${LC_MESSAGES+set}" != 'xset' ]; then
+ if [ "x${LC_ALL+set}" = 'xset' ]; then
+ LC_MESSAGES="${LC_ALL}"
+ elif [ "x${LANG+set}" = 'xset' ]; then
+ LC_MESSAGES="${LANG}"
+ else
+ LC_MESSAGES="${DEFAULT_LOCALE}"
+ fi
+ fi
+
+ # Try to load the locale.
+ if ! _try_load_locale "${LC_MESSAGES%.*}"; then
+ if ! _try_load_locale "${LC_MESSAGES%_*}"; then
+ if ! _try_load_locale "${DEFAULT_LOCALE}"; then
+ printf 'Cannot load locale' >&2
+ return 1
+ fi
+ fi
+ fi
+
+ return 0
+}
+
+get_msg()
+{
+ local msgid="${1}"
+
+ eval "printf '%s' \"\${msg_${TEXT_DOMAIN}_${msgid}}"
+
+ return 0
+}
+
+_try_load_locale()
+{
+ local localedir="${1}"
+ local locale="${2}"
+ local ms
+
+ ms="$(printf "${LOCALE_PATH}" \
+ "${localedir}" "${locale}" "${TEXT_DOMAIN}")"
+
+ if [ -f "${ms}" ]; then
+ . "${ms}"
+ else
+ return 1
+ fi
+
+ return 0
+}